#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
import os
import time

import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk, GLib, GObject

from conexion.servidorVNC import ConectarServidorVNC as conexion

GObject.threads_init()

class Handler:
    ##SIGNAL HANDLERS ####################
    
    def noEscribas(self):
        
        #x.main_window.set_deletable(False)
        x.passwd.set_sensitive(False)
        x.botonDesconectar.set_sensitive(True)
        time.sleep(0.5)
        x.botonConectar.set_sensitive(False)
        x.lbConectado.show()


    def wait_for_t(self,t):
        if not t.is_alive():
           self.on_boton_desconectar_clicked(x.botonDesconectar)
        else:
            GObject.timeout_add(200, self.wait_for_t, t)
    
    def iniciaServer(self):
        t = conexion.iniciarServer(x.passwd.get_text())
        t.Daemon = True
        t.start()
        time.sleep(0.5)
        self.wait_for_t(t)
        #t.join(0.05)            
        #self.on_boton_desconectar_clicked(x.botonDesconectar)
    
    def compruebaPassword(self, widget):
        palabra= widget.get_text().lower()
        correcto = True
        if len(palabra)==0 or palabra.isspace():
            x.labelwarning.show()
            x.labelwarning.set_markup("Debe escribir algo")
            x.passwd.set_text("")
            correcto = False
        elif len(palabra)<4:
            x.labelwarning.show()
            x.labelwarning.set_markup("Escriba una contraseña de \n4 caracteres como mínimo.")
            x.passwd.set_text("")
            correcto= False
        else:
            for p in palabra:
                if p.isspace():
                    x.labelwarning.show()
                    x.labelwarning.set_markup("No escriba espacios")
                    x.passwd.set_text("")
                    correcto=False
        return correcto
    
    def on_main_window_destroy (self, widget):
        self.on_boton_desconectar_clicked(x.botonDesconectar)
        os.system("pkill -9 x11vnc")
        Gtk.main_quit()
        sys.exit(0)    
    
    def on_boton_conectar_clicked (self, button):
        
        x.labelwarning.hide()
        okPass = self.compruebaPassword(x.passwd)
        if okPass:
            self.noEscribas()
            time.sleep(0.5)
            GLib.idle_add(self.iniciaServer)
    
    def on_boton_desconectar_clicked (self, button):
        
        #x.main_window.set_deletable(True)
        os.system("pkill -9 x11vnc")
        x.lbConectado= x.builder.get_object("lbconexion")
        x.lbConectado.hide()
        x.botonConectar.set_sensitive(True)
        x.botonDesconectar.set_sensitive(False)
        x.passwd.set_sensitive(True)
        
        
        

class VncServerPizarra(object):
    
    def __init__(self):
        self.builder = Gtk.Builder()
        self.builder.add_from_file("/usr/share/educaandos-simple-remote-control/glade/file.glade")
        self.builder.connect_signals(Handler())

        self.botonConectar= self.builder.get_object("boton_conectar")
        self.botonDesconectar= self.builder.get_object("boton_desconectar")
        self.botonDesconectar.set_sensitive(False)
        self.passwd = self.builder.get_object("text_password")
        self.passwd.set_visibility(False)
        
        self.main_window = self.builder.get_object("main_window")
        #self.main_window.set_default(self.botonConectar)
        self.passwd.set_activates_default(True)
            
        self.lbConectado= self.builder.get_object("lbconexion")
        self.labelwarning = self.builder.get_object("labelwarning")
        
        
        
        ##Mostrar ventana
        self.main_window.show()
    
    def muestraIP(self):
        
        import netifaces
        from netifaces import interfaces, ifaddresses, AF_INET
        
        def ipv4():                
            ip_list = []
            for interface in interfaces():
                addrs= netifaces.ifaddresses(interface)
                if netifaces.AF_INET in addrs.keys():
                    ip_list.append(addrs[netifaces.AF_INET])
                                
            for ip in ip_list:
                ipAddr=ip[0].get('addr')
                ip = ipAddr.split('.')
                if ip[0]!='127':
                    return ipAddr
                
        label = self.builder.get_object("direccion_ip")
        mi_ip =ipv4()
        if mi_ip == None:
            label.set_markup("Sin conexión")
        else:
            label.set_markup(mi_ip)

    def main (self):
        Gtk.main()

x = VncServerPizarra()
x.muestraIP()
x.main()

                    
